include(CheckCXXCompilerFlag)
include(CheckCCompilerFlag)
include(CheckAndAddWarnings)

function(CheckAndAddFlag flag)
  make_flag_for_check(${flag} checkedFlag)
  # Remove special chars
  string(MAKE_C_IDENTIFIER ${checkedFlag} VarName)
  check_cxx_compiler_flag(${checkedFlag} CXX_FLAG_${VarName}_SUPPORTED)
  check_c_compiler_flag(${checkedFlag} C_FLAG_${VarName}_SUPPORTED)
  if(CXX_FLAG_${VarName}_SUPPORTED AND C_FLAG_${VarName}_SUPPORTED)
    add_compile_options(${flag})
  elseif(CXX_FLAG_${VarName}_SUPPORTED)
    add_compile_options($<$<COMPILE_LANGUAGE:CXX>:${flag}>)
  elseif(C_FLAG_${VarName}_SUPPORTED)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:${flag}>)
  endif()
endfunction()

function(CheckAndAddFlags)
  foreach(flag ${ARGN})
    CheckAndAddFlag(${flag})
  endforeach()
endfunction()
